 
%% Signal
N = 1024;
t = (0:N-1)/N;

a    = 2;
s = a.*exp(2*pi*1i*(130*t+100*t.^2));
phi1 = 130+200*t;

%% Parameters
 gamma = 0.01;
 sigma = 0.04;

 % Choice of time and frequency bins
 ft = 1:N/2;
 bt = 1:N;
 
 %% Compute TF transforms
 Nfft1 = N;
 [STFT,SST,VSST]    = sst2_new(s,1/sigma^2/N,Nfft1,gamma);
 Nfft2 = 2*N;
 [STFT1,SST1,VSST1] = sst2_new(s,1/sigma^2/N,Nfft2,gamma);
 Nfft3 = 4*N;
 [STFT2,SST2,VSST2] = sst2_new(s,1/sigma^2/N,Nfft3,gamma);
 Nfft4 = 8*N;
 [STFT3,SST3,VSST3] = sst2_new(s,1/sigma^2/N,Nfft4,gamma);
 Nfft5 = 16*N;
 [STFT4,SST4,VSST4] = sst2_new(s,1/sigma^2/N,Nfft5,gamma);
 
 %[STFT,SST,VSST,omega,tau,omega2] = sst2(s,gamma,sigma,ft,bt);
 t  = (0:N-1)/N;
 fs = N/Nfft1*(0:Nfft1/2-1);
 
 %STFT image
 
 imagesc(t,fs,abs(STFT));
 set(gca,'YDir','normal')
 axis square
 pause
 
 %Computation of the ridges with no regularization, effect of zero padding 
 beta   = 0;
 lambda = 0;
 [Cs0, Es] = exridge(STFT,lambda,beta,10);    
 [Cs1, Es] = exridge(SST,lambda,beta,10);
 [Cs2, Es] = exridge(VSST,lambda,beta,10);
 [Cs01,Es] = exridge(STFT1,lambda,beta,10);    
 [Cs11,Es] = exridge(SST1,lambda,beta,10);
 [Cs21,Es] = exridge(VSST1,lambda,beta,10);
 [Cs02,Es] = exridge(STFT2,lambda,beta,10);    
 [Cs12,Es] = exridge(SST2,lambda,beta,10);
 [Cs22,Es] = exridge(VSST2,lambda,beta,10);
 [Cs03,Es] = exridge(STFT3,lambda,beta,10);    
 [Cs13,Es] = exridge(SST3,lambda,beta,10);
 [Cs23,Es] = exridge(VSST3,lambda,beta,10);
 [Cs04,Es] = exridge(STFT4,lambda,beta,10);    
 [Cs14,Es] = exridge(SST4,lambda,beta,10);
 [Cs24,Es] = exridge(VSST4,lambda,beta,10);

 figure()
 
 %STFT
 plot(t,N/Nfft1*(Cs0-1),'-.',t,N/Nfft2*(Cs01-1),'--',t,N/Nfft3*(Cs02-1),':',t,N/Nfft4*(Cs03-1),'-*',t,phi1);
 set(gca,'xlim',[0.33 0.34]);
 axis square
 
 %SST
 pause
 figure()
 plot(t,N/Nfft1*(Cs1-1),'-.',t,N/Nfft2*(Cs11-1),'--',t,N/Nfft3*(Cs12-1),':',t,N/Nfft4*(Cs13-1),'-*',t,phi1);
 set(gca,'xlim',[0.33 0.34]);
 axis square
 pause

 %VSST 
 figure()
 plot(t,N/Nfft1*(Cs2-1),'-.',t,N/Nfft2*(Cs21-1),'--',t,N/Nfft3*(Cs22-1),':',t,N/Nfft4*(Cs23-1),'-*',t,phi1);
 set(gca,'xlim',[0.33 0.34]); 
 axis square
 pause
 
 

