
%% Signal
N = 1024;
t = (0:N-1)/N;

a  = 2;
s1 = a.*exp(2*pi*1i*(250*t+50*t.^3));
s2 = a.*exp(2*pi*1i*(130*t+100*t.^2));
s3 = a.*exp(2*pi*1i*(90*t+0.2*cos(3*pi*t)));
s  = s1+s2+s3;
 
%% Parameters
sigma = 0.04;
gamma = 0.01;

% Choice of time and frequency bins
ft = 1:N/2;
bt = 1:N;

% reconstruction parameters
lambda = 0;
beta   = 0;


%% Compute TF transforms
s = add_awgn_noise(s,0); 

%% Compute TF transforms signal s1
[STFT,SST,VSST]    = sst2_new_gamma_adapt(s,1/sigma^2/N,N);

%Figure A
fs = 0:N/2-1;
imagesc(t,fs,abs(VSST));
set(gca,'YDir','normal')
colormap(1-gray)

Nfft1 = 8*N;
[STFT,SST,VSST]    = sst2_new_gamma_adapt(s,1/sigma^2/N,Nfft1);
nr    = 3; %number of modes to be detected
clwin = 10;   
[Cs, Es] = exridge_mult(VSST,nr,lambda,beta,clwin);

for k = 1:nr,
%  [indmin,indmax,indzer] = extrbis(Cs(k,:)-1);
% 
%  if (length(indmin)>=2)&&(length(indmax)>=2)
%   [imf]   = emdbis(Cs(k,:)-1);
%   R_vsst  = Cs(k,:)-1-imf(1,:);
%  else
%   R_vsst  = Cs(k,:)-1;  
%  end
 
 %numerical integration of R_vsst
 integ = cumtrapz(t,N/Nfft1*(Cs(k,:)-1));
 sp = s.*exp(-2*1i*pi*(integ-100.*t));
 
 %perform the sunchrosqueezing transform on the demodulated modes 
 [STFT1,SST1,VSST1] = sst2_new_gamma_adapt(sp,1/sigma^2/N,N);
  
  %Figure B C D
  figure()
  imagesc(t,fs,abs(VSST1));
  if k == 1, 
   set(gca,'ylim',[0 200]);
  elseif k == 2,
    set(gca,'ylim',[0 250]);
  end  
  set(gca,'YDir','normal')
  colormap(1-gray)
end

