 
function Fig4(cas,jump)
%% Signal
N = 1024;
t = (0:N-1)/N;

a    = 2;
if (cas == 1),
 %linear chirp
 s = a.*exp(2*pi*1i*(130*t+100*t.^2));
 phi1 = 130+200*t;
elseif (cas == 2),
 %polynomial chirp   
 s   = a.*exp(2*pi*1i*(250*t+50*t.^3));
 phi1 = 250+150*t.^2;
else
 %sinusoidal wave   
 s = a.*exp(2*pi*1i*(330*t+16*cos(3*pi*t)));
 phi1 = 330-16*3*pi*sin(3*pi*t);   
end
%% Parameters
 gamma = 0.01;
 sigma = 0.04;
 
 %% Compute TF transforms
 Nfft1 = N;
 [STFT,SST,VSST]    = sst2_new(s,1/sigma^2/N,Nfft1,gamma);
 Nfft2 = 2*N;
 [STFT1,SST1,VSST1] = sst2_new(s,1/sigma^2/N,Nfft2,gamma);
 Nfft3 = 4*N;
 [STFT2,SST2,VSST2] = sst2_new(s,1/sigma^2/N,Nfft3,gamma);
 Nfft4 = 8*N;
 [STFT3,SST3,VSST3] = sst2_new(s,1/sigma^2/N,Nfft4,gamma);
 Nfft5 = 16*N;
 [STFT4,SST4,VSST4] = sst2_new(s,1/sigma^2/N,Nfft5,gamma);
 
 %Computation of the ridges with no regularization, effect of zero padding 
 beta   = 0;
 lambda = 0;
 [Cs2, Es] = exridge(VSST,lambda,beta,jump);
 [Cs21,Es] = exridge(VSST1,lambda,beta,jump);
 [Cs22,Es] = exridge(VSST2,lambda,beta,jump);
 [Cs23,Es] = exridge(VSST3,lambda,beta,jump);
 [Cs24,Es] = exridge(VSST4,lambda,beta,jump);

 %improvement with EMD
 [indmin,indmax,indzer] = extrbis(Cs2-1);

 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs2-1);
  R_vsst0  = Cs2-1-imf(1,:);
 else
  R_vsst0  = Cs2-1;  
 end
 
 [indmin,indmax,indzer] = extrbis(Cs21-1);
 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs21-1);
  R_vsst1  = Cs21-1-imf(1,:);
 else
  R_vsst1  = Cs21-1;  
 end
 
 [indmin,indmax,indzer] = extrbis(Cs22-1);
 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs22-1);
  R_vsst2  = Cs22-1-imf(1,:);
 else
  R_vsst2  = Cs22-1;  
 end
 
 [indmin,indmax,indzer] = extrbis(Cs23-1);
 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs23-1);
  R_vsst3  = Cs23-1-imf(1,:);
 else
  R_vsst3  = Cs23-1;  
 end
 
 
 [indmin,indmax,indzer] = extrbis(Cs24-1);
 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs24-1);
  R_vsst4  = Cs24-1-imf(1,:);
 else
  R_vsst4  = Cs24-1;  
 end
 
 
 MSE =zeros(8,5);
 index = 100:N-100;
 
 MSE(1,:) = [ sqrt(sum((N/Nfft1*(Cs2(index)-1)-phi1(index)).^2)/(length(index)-1)) sqrt(sum((N/Nfft2*(Cs21(index)-1)-phi1(index)).^2)/(length(index)-1))...
              sqrt(sum((N/Nfft3*(Cs22(index)-1)-phi1(index)).^2)/(length(index)-1)) sqrt(sum((N/Nfft4*(Cs23(index)-1)-phi1(index)).^2)/(length(index)-1))... 
              sqrt(sum((N/Nfft5*(Cs24(index)-1)-phi1(index)).^2)/(length(index)-1))]; 
 
 MSE(2,:) = [ sqrt(sum((N/Nfft1*R_vsst0(index)-phi1(index)).^2)/(length(index)-1)) sqrt(sum((N/Nfft2*R_vsst1(index)-phi1(index)).^2)/(length(index)-1))...
              sqrt(sum((N/Nfft3*R_vsst2(index)-phi1(index)).^2)/(length(index)-1)) sqrt(sum((N/Nfft4*R_vsst3(index)-phi1(index)).^2)/(length(index)-1))... 
              sqrt(sum((N/Nfft5*R_vsst4(index)-phi1(index)).^2)/(length(index)-1))]; 
 
          
 %with noise
 p = 3;
 for k = 5:-5:-5,
  k
  MSE_int = zeros(5,2,5); %we consider 5 different realizations 
  for q =1:5
   q
   s0 = add_awgn_noise(s,k);
   [STFT,SST,VSST]    = sst2_new_gamma_adapt(s0,1/sigma^2/N,Nfft1);
   [STFT1,SST1,VSST1] = sst2_new_gamma_adapt(s0,1/sigma^2/N,Nfft2);
   [STFT2,SST2,VSST2] = sst2_new_gamma_adapt(s0,1/sigma^2/N,Nfft3);
   [STFT3,SST3,VSST3] = sst2_new_gamma_adapt(s0,1/sigma^2/N,Nfft4);
   [STFT4,SST4,VSST4] = sst2_new_gamma_adapt(s0,1/sigma^2/N,Nfft5);

   [Cs2, Es] = exridge(VSST,lambda,beta,jump);
   [Cs21,Es] = exridge(VSST1,lambda,beta,jump);
   [Cs22,Es] = exridge(VSST2,lambda,beta,jump);  
   [Cs23,Es] = exridge(VSST3,lambda,beta,jump);    
   [Cs24,Es] = exridge(VSST4,lambda,beta,jump);
   %improvement with EMD
 [indmin,indmax,indzer] = extrbis(Cs2-1);

 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs2-1);
  R_vsst0  = Cs2-1-imf(1,:);
 else
  R_vsst0  = Cs2-1;  
 end
 
 [indmin,indmax,indzer] = extrbis(Cs21-1);
 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs21-1);
  R_vsst1  = Cs21-1-imf(1,:);
 else
  R_vsst1  = Cs21-1;  
 end
 
 [indmin,indmax,indzer] = extrbis(Cs22-1);
 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs22-1);
  R_vsst2  = Cs22-1-imf(1,:);
 else
  R_vsst2  = Cs22-1;  
 end
 
 [indmin,indmax,indzer] = extrbis(Cs23-1);
 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs23-1);
  R_vsst3  = Cs23-1-imf(1,:);
 else
  R_vsst3  = Cs23-1;  
 end
 
 [indmin,indmax,indzer] = extrbis(Cs24-1);
 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs24-1);
  R_vsst4  = Cs24-1-imf(1,:);
 else
  R_vsst4  = Cs24-1;  
 end
 
  %VSST 
  MSE_int(q,1,:) = [ sqrt(sum((N/Nfft1*(Cs2(index)-1)-phi1(index)).^2)/(length(index)-1)) sqrt(sum((N/Nfft2*(Cs21(index)-1)-phi1(index)).^2)/(length(index)-1))...
                     sqrt(sum((N/Nfft3*(Cs22(index)-1)-phi1(index)).^2)/(length(index)-1)) sqrt(sum((N/Nfft4*(Cs23(index)-1)-phi1(index)).^2)/(length(index)-1))... 
                     sqrt(sum((N/Nfft5*(Cs24(index)-1)-phi1(index)).^2)/(length(index)-1))];
  %VSST with EMD
  MSE_int(q,2,:) = [ sqrt(sum((N/Nfft1*R_vsst0(index)-phi1(index)).^2)/(length(index)-1)) sqrt(sum((N/Nfft2*R_vsst1(index)-phi1(index)).^2)/(length(index)-1))...
                 sqrt(sum((N/Nfft3*R_vsst2(index)-phi1(index)).^2)/(length(index)-1)) sqrt(sum((N/Nfft4*R_vsst3(index)-phi1(index)).^2)/(length(index)-1))...
                 sqrt(sum((N/Nfft5*R_vsst4(index)-phi1(index)).^2)/(length(index)-1))]; 

 end
 MSE(p,:) = mean(MSE_int(:,1,:));
 p = p+1;
 MSE(p,:) = mean(MSE_int(:,2,:));
 p = p+1;
end

vec = [1 2 4 8 16];
figure()
plot(vec,MSE(1,:),'--',vec,MSE(2,:),vec,MSE(3,:),':',vec,MSE(4,:),'-*',vec,MSE(5,:),'-o',...
     vec,MSE(6,:),'-d',vec,MSE(7,:),'-s',vec,MSE(8,:),'-<')
         
 
 

