function [snr_1_demod,snr_2_demod,snr_3_demod,snr_1_demod_noopt,snr_2_demod_noopt,snr_3_demod_noopt,snr_1_direct,snr_2_direct,snr_3_direct]=Fig9_New(d,cas)


N = 1024;

% Parameters
gamma = 0.01;
sigma = 0.01:0.01:0.2;
index = N/8+1:7*N/8;
SNR = 0:15;
clwin = 10;
lambda = 0;
beta   = 0;

t = (0:N-1)/N;
f = 0:N/2-1; 

% Choice of time and frequency bins
ft =1:N/2;bt=1:N;

%% Tests signals 1
if (cas == 1)
 a  = 2;%exp(-8*(t-0.5).^2);
 s1 = a.*exp(2*pi*1i*(250*t+100*t.^3));
 s2 = a.*exp(2*pi*1i*(130*t+100*t.^2));
 s3 = a.*exp(2*pi*1i*(90*t+0.2*cos(3*pi*t)));
 s  = s1+s2+s3;
 nr = 3;
else
%% Test signal 2
 a  = 2;%exp(-8*(t-0.5).^2);
 s1 = a.*exp(2*pi*1i*(330*t+16*cos(3*pi*t)));
 s2 = a.*exp(2*pi*1i*(190*t+9*cos(3*pi*t)));
 s  = s1+s2;
 nr = 2;
end 
%% Test signal with noise

snr_direct = zeros(length(SNR),nr);
snr_demod  = zeros(length(SNR),nr);
snr_demod_noopt  = zeros(length(SNR),nr);

for qq = 1:20, %qq realizations ofthe noise
 qq
 for k =1:length(SNR),
   s0  = add_awgn_noise(s,SNR(k));   
   Ren = zeros(length(sigma),1);

   for j = 1:length(sigma)
    [STFT,SST,VSST,omega,tau,omega2] = sst2(s0,gamma,sigma(j),ft,bt);
    Ren(j) =renyi_entropy(abs(VSST),t,f',3);
   end
   
   %optimal sigma
   sigma_optR1 = sigma(Ren==min(Ren));
   
   [STFT,SST,VSST,omega,tau,omega2] = sst2(s0,gamma,sigma_optR1,ft,bt);
   
   [Cs, Es] = exridge_mult(VSST,nr,lambda,beta,clwin);
   
   imf_direct = sigma_optR1*recmodes(VSST,Cs,d);
   if (cas == 1)
    snr_direct(k,:) =  [snr(s1(index),imf_direct(1,index)-s1(index))... 
                        snr(s2(index),imf_direct(2,index)-s2(index))...
                        snr(s3(index),imf_direct(3,index)-s3(index))];
   else
    snr_direct(k,:) =  [snr(s1(index),imf_direct(1,index)-s1(index))... 
                        snr(s2(index),imf_direct(2,index)-s2(index))];
   end
  
   %reconstruction using smooth ridges determined from VSST and smoothed with EMD,
   %and then demodulation 
   imf_demod = zeros(nr,N);
   imf_demod_noopt = zeros(nr,N);%with no optimization on sigma
   
   for q = 1:nr,
    [indmin,indmax,indzer] = extrbis(Cs(q,:)-1);
    if (length(indmin)>=2) && (length(indmax)>=2)
     [imf]   = emdbis(Cs(q,:)-1);
     R_vsst  = Cs(q,:)-1-imf(1,:);
    else
     R_vsst  = Cs(q,:)-1;  
    end
    
    %numerical integration of Y, and demodulation
    integ = cumtrapz(t,R_vsst);
    sp = s0.*exp(-2*1i*pi*(integ-100.*t));
    
    for j = 1:length(sigma)
     [STFT,SST,VSST,omega,tau,omega2] = sst2(sp,gamma,sigma(j),ft,bt);
     Ren(j) =renyi_entropy(abs(VSST),t,f',3);
    end
    
    %optimal sigma
    sigma_opt_demod = sigma(Ren == min(Ren));
    %perform the sunchrosqueezing transform on the demodulated modes using the optimized sigma 
    [STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma_opt_demod,ft,bt);
    %we extract q ridges
    [C, Es] = exridge_mult(SST1,q,lambda,beta,clwin);
   
    %reconstruction of mode k, using the SST
    imf2 = sigma_opt_demod*recmodes(SST1,C(q,:),d);
    imf2 = imf2.*exp(2*1i*pi*(integ-100.*t));
    imf_demod(q,:) = imf2; 
   
    %perform the synchrosqueezing transform on the demodulated modes with
    %no optimization on sigma
    [STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma_optR1,ft,bt);
    %we extract q ridges
    [C1, Es] = exridge_mult(SST1,q,lambda,beta,clwin);
   
    %reconstruction of mode k, using the SST
    imf2 = sigma_optR1*recmodes(SST1,C1(q,:),d);
    imf2 = imf2.*exp(2*1i*pi*(integ-100.*t));
    imf_demod_noopt(q,:) = imf2; 
   end
  
   if (cas == 1)
    snr_demod(k,:) = [snr(s1(index),imf_demod(1,index)-s1(index)) ...
                     snr(s2(index),imf_demod(2,index)-s2(index)) ...
                     snr(s3(index),imf_demod(3,index)-s3(index))];
    snr_demod_noopt(k,:) = [snr(s1(index),imf_demod_noopt(1,index)-s1(index)) ...
                     snr(s2(index),imf_demod_noopt(2,index)-s2(index)) ...
                     snr(s3(index),imf_demod_noopt(3,index)-s3(index))];

   else
    snr_demod(k,:) = [snr(s1(index),imf_demod(1,index)-s1(index)) ...
                     snr(s2(index),imf_demod(2,index)-s2(index))];
    snr_demod_noopt(k,:) = [snr(s1(index),imf_demod_noopt(1,index)-s1(index)) ...
                           snr(s2(index),imf_demod_noopt(2,index)-s2(index))];
   end    
 end
 if (qq==1),
  if (cas == 1)
   snr_1_demod = snr_demod(:,1);
   snr_2_demod = snr_demod(:,2);
   snr_3_demod = snr_demod(:,3);
   snr_1_demod_noopt = snr_demod_noopt(:,1);
   snr_2_demod_noopt = snr_demod_noopt(:,2);
   snr_3_demod_noopt = snr_demod_noopt(:,3);
   snr_1_direct = snr_direct(:,1);
   snr_2_direct = snr_direct(:,2);
   snr_3_direct = snr_direct(:,3);
  else
   snr_1_demod = snr_demod(:,1);
   snr_2_demod = snr_demod(:,2);
   snr_1_demod_noopt = snr_demod_noopt(:,1);
   snr_2_demod_noopt = snr_demod_noopt(:,2);
   snr_1_direct = snr_direct(:,1);
   snr_2_direct = snr_direct(:,2);
  end
 else
  if (cas == 1)
   snr_1_demod = [snr_1_demod snr_demod(:,1)];
   snr_2_demod = [snr_2_demod snr_demod(:,2)];
   snr_3_demod = [snr_3_demod snr_demod(:,3)];
   snr_1_demod_noopt = [snr_1_demod_noopt snr_demod(:,1)];
   snr_2_demod_noopt = [snr_2_demod_noopt snr_demod(:,2)];
   snr_3_demod_noopt = [snr_3_demod_noopt snr_demod(:,3)];
   snr_1_direct = [snr_1_direct snr_direct(:,1)];
   snr_2_direct = [snr_2_direct snr_direct(:,2)];
   snr_3_direct = [snr_3_direct snr_direct(:,3)];

  else
   snr_1_demod = [snr_1_demod snr_demod(:,1)];
   snr_2_demod = [snr_2_demod snr_demod(:,2)];
   snr_1_demod_noopt = [snr_1_demod_noopt snr_demod(:,1)];
   snr_2_demod_noopt = [snr_2_demod_noopt snr_demod(:,2)];
   snr_1_direct = [snr_1_direct snr_direct(:,1)];
   snr_2_direct = [snr_2_direct snr_direct(:,2)];
  end
 end
end 
 if cas == 2
  snr_3_demod = 0;
  snr_3_demod_noopt = 0;
  snr_3_direct = 0;
 end 
end
 