%% Signal
N = 1024;
t = (0:N-1)/N;

a  = 1;%exp(-8*(t-0.5).^2);
s1 = a.*exp(2*pi*1i*(250*t+100*t.^3));
s2 = a.*exp(2*pi*1i*(130*t+100*t.^2));
s3 = a.*exp(2*pi*1i*(90*t+0.2*cos(3*pi*t)));
s  = s1+s2+s3;

%% Parameters
gamma = 0.01;
sigma = 0.04;

% Choice of time and frequency bins
ft =1:N/2;
bt=1:N;

% reconstruction parameters
clwin  = 10;
lambda = 0;
beta   = 0;
d = 0;
index = N/8:N-N/8;

%% Compute TF transforms

[STFT,SST,VSST,omega,tau,omega2] = sst2(s,gamma,sigma,ft,bt);

nr = 3;
[Cs, Es] = exridge_mult(VSST,nr,lambda,beta,clwin);

%direct reconstruction using VSST, without smoothing the ridges 

imf_direct = sigma*recmodes(VSST,Cs,d);
snr_direct = [snr(s1(index),imf_direct(1,index)-s1(index)) snr(s2(index),imf_direct(2,index)-s2(index)) snr(s3(index),imf_direct(3,index)-s3(index))];

%reconstruction using VSST, smoothed ridges computed with EMD and demodulation algorithm 
imf_demod = zeros(3,N);
for k = 1:nr,
 
 [indmin,indmax,indzer] = extrbis(Cs(k,:)-1);

 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs(k,:)-1);
  R_vsst  = Cs(k,:)-1-imf(1,:);
 else
  R_vsst  = Cs(k,:)-1;  
 end
 
 %numerical integration of Y, and demodulation
 integ = cumtrapz(t,R_vsst);
 sp = s.*exp(-2*1i*pi*(integ-100.*t));
 
 %perform the sunchrosqueezing transform on the demodulated modes 
 [STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma,ft,bt);
 
 %we extract k ridges, now we can't use the imf
 [C, Es] = exridge_mult(SST1,k,lambda,beta,clwin);
 %reconstruction of mode k
 imf1 = sigma*recmodes(SST1,C(k,:),d);
 imf1 = imf1.*exp(2*1i*pi*(integ-100.*t));
 imf_demod(k,:) = imf1;
end
 
snr_demod = [snr(s1(index),imf_demod(1,index)-s1(index)) snr(s2(index),imf_demod(2,index)-s2(index)) snr(s3(index),imf_demod(3,index)-s3(index))];

t1 = t((t>=0.26)&(t<=0.3));
s11 = s1((t>=0.26)&(t<=0.3));
imf1 = imf_direct(1,(t>=0.26)&(t<=0.3));
imf2 = imf_demod(1,(t>=0.26)&(t<=0.3));
subplot(3,1,1), plot(t,real(s1))
subplot(3,1,2), plot(t1,real(s11),t1,real(imf1),'-.')
subplot(3,1,3), plot(t1,real(s11),t1,real(imf2),'--')
