function [snr_direct,snr_demod_noopt,snr_demod] =fig8_entropy(d,cas)

%% Signal
%N = 2048;
N = 1024;
t = (0:N-1)/N;
f = 0:N/2-1;
%test signal 1
if (cas == 2)
 %test signal 1
 a  = 2;
 s1 = exp(2*pi*1i*(330*t+16*cos(3*pi*t)));
 s2 = exp(2*pi*1i*(190*t+9*cos(3*pi*t)));
 %s3 = exp(2*pi*1i*(40*t));
 s  = s1+s2;%+s3;
else
 %test signal 2
 a  = 2;
 s1 = a.*exp(2*pi*1i*(250*t+100*t.^3));
 s2 = a.*exp(2*pi*1i*(130*t+100*t.^2));
 s3 = a.*exp(2*pi*1i*(90*t+0.2*cos(3*pi*t)));%low frequency component
 s  = s1+s2+s3;
end

%% Parameters
gamma = 0.01;
if cas == 1
  nr = 3;
 else
  nr = 2;
end
sigma = 0.01:0.01:0.2;

% Choice of time and frequency bins
ft = 1:N/2;
bt = 1:N; 

% reconstruction parameters
clwin = 10;
lambda = 0; %no regularization
beta  =  0;

%we only consider the inner part
index = N/8+1:7*N/8;
Ren = zeros(1,length(sigma));

for p = 1:20,
 %% Compute TF transforms
 [STFT,SST,VSST,omega,tau,omega2] = sst2(s,gamma,sigma(p),ft,bt);
 Ren(p)  = renyi_entropy(abs(VSST),t,f',3);
end

sigma_optR1 = sigma(Ren==min(Ren));

[STFT,SST,VSST,omega,tau,omega2] = sst2(s,gamma,sigma_optR1,ft,bt);
[Cs, Es] = exridge_mult(VSST,nr,lambda,beta,clwin);
 
%direct reconstruction using ridges determined from VSST  
imf_direct = sigma_optR1*recmodes(VSST,Cs,d);
if (cas == 1)
 snr_direct = [snr(s1(index),imf_direct(1,index)-s1(index))...
               snr(s2(index),imf_direct(2,index)-s2(index))...
               snr(s3(index),imf_direct(3,index)-s3(index))];
else
 snr_direct =  [snr(s1(index),imf_direct(1,index)-s1(index))... 
                snr(s2(index),imf_direct(2,index)-s2(index))];
end
  
%reconstruction using smooth ridges determined from VSST and smoothed with EMD,
%and then demodulation 
imf_demod = zeros(nr,N);
imf_demod_noopt = zeros(nr,N);
 
for k = 1:nr,
  [indmin,indmax,indzer] = extrbis(Cs(k,:)-1);
  if (length(indmin)>=2)&&(length(indmax)>=2)
   [imf]   = emdbis(Cs(k,:)-1);
   R_vsst  = Cs(k,:)-1-imf(1,:);
  else
   R_vsst  = Cs(k,:)-1;  
  end
  %numerical integration of Y, and demodulation
  integ = cumtrapz(t,R_vsst);
  sp = s.*exp(-2*1i*pi*(integ-100.*t));
 
  %perform the sunchrosqueezing transform on the demodulated modes 
  [STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma_optR1,ft,bt);
  %we extract k ridges
  [C, Es] = exridge_mult(VSST1,k,lambda,beta,clwin);
  
  %reconstruction of mode k, using the SST
  imf2 = sigma_optR1*recmodes(SST1,C(k,:),d);
  imf2 = imf2.*exp(2*1i*pi*(integ-100.*t));
  imf_demod_noopt(k,:) = imf2;
  
  for p = 1:20,
  %% Compute TF transforms
   [STFT,SST,VSST,omega,tau,omega2] = sst2(sp,gamma,sigma(p),ft,bt);
   Ren(p) =renyi_entropy(abs(VSST),t,f',3);
  end
  sigma_optR2 = sigma(Ren==min(Ren));
  %we extract k ridges
  [STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma_optR2,ft,bt);
  [C1, Es] = exridge_mult(VSST1,k,lambda,beta,clwin);
  
  %reconstruction of mode k, using the SST
  imf2 = sigma_optR2*recmodes(SST1,C1(k,:),d);
  imf2 = imf2.*exp(2*1i*pi*(integ-100.*t));
  imf_demod(k,:) = imf2;
end
 
if (cas == 1)
    
 snr_demod       = [snr(s1(index),imf_demod(1,index)-s1(index)) ...
                    snr(s2(index),imf_demod(2,index)-s2(index)) ...
                    snr(s3(index),imf_demod(3,index)-s3(index))];

 snr_demod_noopt = [snr(s1(index),imf_demod_noopt(1,index)-s1(index)) ...
                    snr(s2(index),imf_demod_noopt(2,index)-s2(index)) ...
                    snr(s3(index),imf_demod_noopt(3,index)-s3(index))];
else
 snr_demod = [snr(s1(index),imf_demod(1,index)-s1(index)) ...
                    snr(s2(index),imf_demod(2,index)-s2(index))];
  
 snr_demod_noopt = [snr(s1(index),imf_demod_noopt(1,index)-s1(index)) ...
                    snr(s2(index),imf_demod_noopt(2,index)-s2(index))];
end    
end
